import win32com.client
from unicode_support import make_string
from com import ensure_init, _tmap_
from RoleCache import RoleCache, getCache, SYSTEM_ENCODING
from Globals import DTMLFile
from AccessControl.User import _remote_user_mode, getSecurityManager

_editUser = DTMLFile('dtml/editUser', globals(), remote_user_mode__=_remote_user_mode)
 

def _getUserInfo(self, _has_adsgf):
    global cache
    cache = getCache()
    try:
        # Make it compatible with jcNTUserFolder
        username = self.ntname
    except:
        username = self.name
    userinfo = cache.getUserInfo()

    if userinfo is not None:
        if userinfo.get(username) is not None:
            return userinfo

    userinfo = {}  
    groupnames=[]
    ensure_init()
    ads_folder_name, ads_folder_obj = _has_adsgf[0]
    adsns = win32com.client.Dispatch('ADsNameSpaces')
    ldapns = adsns.GetObject('','LDAP:')
    adocon = win32com.client.Dispatch('ADODB.Connection')
    adocon.Provider = 'ADsDSOObject'
    adocon.Open('Active Directory Provider')
    attrs = ['distinguishedname']
    cmd = win32com.client.Dispatch('ADODB.Command')
    cmd.ActiveConnection = adocon
    domain = ads_folder_obj.ldap_domain
    baseDN = ads_folder_obj.base_dn
    attrs = ['distinguishedName']
    ldap_filter = '(&(objectclass=User)(samaccountname=%s))' % username
    scope = ads_folder_obj.search_scope
    url = 'LDAP://shermfin.com/dc=shermfin,dc=com'
    cmd_text = '<%s>;%s;%s;%s' % (url, ldap_filter.strip(),
                                  ','.join(attrs), scope)
    cmd.CommandText = cmd_text
    rs = cmd.Execute()[0]
    if rs.RecordCount:       
        userDN = rs.Fields(0).Value
        objUser = ldapns.GetObject('', userDN)
        objUser.GetInfo()
        groups=[]
        for g in objUser.Groups():
            groupnames.append(make_string(g.SAMAccountName))
    else:
        groupnames=[]
      
    userinfo[username] = {'roles': groupnames}
    cache.cacheUserInfo(userinfo)
    return userinfo

def getRoles(self):
    """Return the list of roles assigned to a user."""

    has_adsgf = None

    # This is ugly!
    root = getSecurityManager().getUser().getPhysicalRoot()    
    has_adsgf = root.ZopeFind(root, obj_metatypes=['ADS Groups Folder'], search_sub=0)
    
    if has_adsgf is not None:
        
        userinfo = _getUserInfo(self, has_adsgf)
        try:
            # Make it compatible with jcNTUserFolder
            username = self.ntname
        except:
            username = self.name

        if userinfo is not None:
            user = userinfo.get(username)
            if user is not None:
                return tuple(self.roles) + tuple([k.encode(SYSTEM_ENCODING) for k in user['roles']]) + ('Authenticated',)
        if self.name == 'Anonymous User': 
            return tuple(self.roles)
        else: 
            return tuple(self.roles) + ('Authenticated',)
    else:
        if self.name == 'Anonymous User': return tuple(self.roles)
        else: return tuple(self.roles) + ('Authenticated',)

